package external

import (
	occe "git.loafle.net/overflow/commons-go/config/external"
	"git.loafle.net/overflow/gateway/external/grpc"
	"git.loafle.net/overflow/gateway/external/kafka"
	"git.loafle.net/overflow/gateway/external/redis"
)

func InitPackage(config *occe.ExternalConfig) {
	if nil == config {
		return
	}
	grpc.InitPackage(config.GRPC)
	redis.InitPackage(config.Redis)
	kafka.InitPackage(config.Kafka)
}

func StartPackage(config *occe.ExternalConfig) {
	if nil == config {
		return
	}
	grpc.StartPackage(config.GRPC)
	redis.StartPackage(config.Redis)
	kafka.StartPackage(config.Kafka)
}

func StopPackage(config *occe.ExternalConfig) {
	if nil == config {
		return
	}
	grpc.StopPackage(config.GRPC)
	redis.StopPackage(config.Redis)
	kafka.StopPackage(config.Kafka)
}

func DestroyPackage(config *occe.ExternalConfig) {
	if nil == config {
		return
	}
	grpc.DestroyPackage(config.GRPC)
	redis.DestroyPackage(config.Redis)
	kafka.DestroyPackage(config.Kafka)
}
